VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cModals"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'NET_API_STATUS NetUserModalsGet(
'  LPCWSTR servername,
'  DWORD level,
'  LPBYTE *bufptr
Private Declare Function NetUserModalsGet _
   Lib "netapi32" _
   (ServerName As Byte, _
    ByVal level As Long, _
    BufferPtr As Long) As Long
    
Private Declare Sub CopyMem _
   Lib "kernel32" Alias "RtlMoveMemory" _
   (pTo As Any, _
    uFrom As Any, _
    ByVal lSize As Long)
Private Declare Function StrLenA _
   Lib "kernel32" Alias "lstrlenA" _
   (ByVal lpString As Any) As Long
Private Declare Function lstrlenW _
   Lib "kernel32" _
   (ByVal lpString As Long) As Long
Private Declare Function StrLenW _
   Lib "kernel32" Alias "lstrlenW" _
   (ByVal Ptr As Long) As Long
Private Declare Function lstrcpy _
   Lib "kernel32" Alias "lstrcpyA" _
   (ByVal lpString1 As Any, _
    ByVal lpString2 As Any) As Long

Public Enum enmCallLevels
   Level_0 = 0
   Level_1 = 1
   Level_2 = 2
   Level_3 = 3
End Enum

Private Const NERR_SUCCESS             As Long = 0&
Private Const TIMEQ_FOREVER            As Long = -1&

Private Const UAS_ROLE_STANDALONE      As Long = 0&
Private Const UAS_ROLE_MEMBER          As Long = 1&
Private Const UAS_ROLE_BACKUP          As Long = 2&
Private Const UAS_ROLE_PRIMARY         As Long = 3&

Private Type Struct_0
   usrmod0_min_passwd_len              As Long
   usrmod0_max_passwd_age              As Long
   usrmod0_min_passwd_age              As Long
   usrmod0_force_logoff                As Long
   usrmod0_password_hist_len           As Long
End Type

'  DWORD    usrmod1_role;
'  LPWSTR   usrmod1_primary;
Private Type Struct_1
  usrmod1_role                         As Long
  usrmod1_primary                      As Long
End Type

'  LPWSTR  usrmod2_domain_name;
'  PSID    usrmod2_domain_id;
Private Type Struct_2
  usrmod2_domain_name                  As Long
  usrmod2_domain_id                    As Long
End Type

Private Type Struct_3
  usrmod3_lockout_duration             As Long
  usrmod3_lockout_observation_window   As Long
  usrmod3_lockout_threshold            As Long
End Type

Public Function GetUserModals(ByVal CallLevel As enmCallLevels, _
                              ByVal ServerName As String) As Variant
   Dim p_abytServerName()              As Byte
   Dim p_lngRtn                        As Long
   Dim p_lngPtrBuffer                  As Long
   Dim p_typStruct_0                   As Struct_0
   Dim p_typStruct_1                   As Struct_1
   Dim p_typStruct_2                   As Struct_2
   Dim p_typStruct_3                   As Struct_3
   Dim p_strRtn                        As String
   Dim p_lngMaxGracePeriod             As Long
   Dim p_strMaxGracePeriod             As String
   
   Select Case CallLevel
      Case Level_0, _
           Level_1, _
           Level_2, _
           Level_3
         ' OK -- continue
      Case Else
         MsgBox "Invalid call level: " & CallLevel, _
                vbOKOnly, "Input Error"
   End Select
   
   ' ------------------------------------------
   ' Convert server name to a byte array
   ' ------------------------------------------
   If Len(Trim$(ServerName)) = 0 Then
      p_abytServerName = vbNullChar
   Else
      If Left$(ServerName, 2) <> "\\" Then
         ServerName = "\\" & ServerName
      End If
      p_abytServerName = ServerName & vbNullChar
   End If
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetUserModalsGet(ServerName:=p_abytServerName(0), _
                               level:=CallLevel, _
                               BufferPtr:=p_lngPtrBuffer)
   If p_lngRtn <> NERR_SUCCESS Then
      MsgBox "Error calling NetUserModalsGet: " & CStr(p_lngRtn), _
             vbOKOnly, "API Call Failed"
      Exit Function
   End If
   
   ' ------------------------------------------
   ' Convert to the type of structure requested
   '     and construct the return string
   ' ------------------------------------------
   Select Case CallLevel
      Case Level_0
         CopyMem p_typStruct_0, _
                 ByVal p_lngPtrBuffer, _
                 Len(p_typStruct_0)
                 
         p_lngMaxGracePeriod = p_typStruct_0.usrmod0_force_logoff
         If p_lngMaxGracePeriod = TIMEQ_FOREVER Then
            p_strMaxGracePeriod = "Never Force Logoff"
         Else
            p_strMaxGracePeriod = CStr(SecondsToDays(p_lngMaxGracePeriod)) & " days"
         End If
         
         p_strRtn = "Force Logoff Grace Time: " & p_strMaxGracePeriod & vbCrLf & _
                    "Maximum Password Age: " & CStr(SecondsToDays(p_typStruct_0.usrmod0_max_passwd_age)) & " days" & vbCrLf & _
                    "Minimum Password Age: " & CStr(SecondsToDays(p_typStruct_0.usrmod0_min_passwd_age)) & " days" & vbCrLf & _
                    "Minimum Password Length: " & p_typStruct_0.usrmod0_min_passwd_len & " characters" & vbCrLf & _
                    "Password History Length: " & p_typStruct_0.usrmod0_password_hist_len & " passwords maintained"
      
      Case Level_1
         CopyMem p_typStruct_1, _
                 ByVal p_lngPtrBuffer, _
                 Len(p_typStruct_1)
         p_strRtn = "Name of Primary DC: " & PointerToStringW(p_typStruct_1.usrmod1_primary) & " " & vbCrLf & _
                    TransUserRole(p_typStruct_1.usrmod1_role)
      
      Case Level_2
         CopyMem p_typStruct_2, _
                 ByVal p_lngPtrBuffer, _
                 Len(p_typStruct_2)
         Debug.Print
         p_strRtn = "Domain ID: " & modSID.GetTextualSid(p_typStruct_2.usrmod2_domain_id) & " " & vbCrLf & _
                    "Domain Name: " & PointerToStringW(p_typStruct_2.usrmod2_domain_name)
      
      Case Level_3
         CopyMem p_typStruct_3, _
                 ByVal p_lngPtrBuffer, _
                 Len(p_typStruct_3)
         p_strRtn = "Lockout Duration: " & CStr(SecondsToHours(p_typStruct_3.usrmod3_lockout_duration)) & " hours" & vbCrLf & _
                    "Lockout Observation Window: " & CStr(SecondsToHours(p_typStruct_3.usrmod3_lockout_observation_window)) & " hours" & vbCrLf & _
                    "Lockout Threshold: " & p_typStruct_3.usrmod3_lockout_threshold & " invalid password attempts"
   End Select

   GetUserModals = p_strRtn
   
End Function

Private Function SecondsToHours(ByVal xi_lngSeconds As Long) As Double
   SecondsToHours = xi_lngSeconds / (60& * 60&)
End Function

Private Function SecondsToDays(ByVal xi_lngSeconds As Long) As Double
   SecondsToDays = xi_lngSeconds / (60& * 60& * 24&)
End Function

Private Function TransUserRole(ByVal xi_lngUserRole As Long) As String

   Select Case xi_lngUserRole
   
      Case UAS_ROLE_STANDALONE
         TransUserRole = "Logon server is a stand-alone server"
      Case UAS_ROLE_MEMBER
         TransUserRole = "Logon server is a member"
      Case UAS_ROLE_BACKUP
         TransUserRole = "Logon server is a backup"
      Case UAS_ROLE_PRIMARY
         TransUserRole = "Logon server is a domain controller"
      Case Else
         TransUserRole = "UNKNOWN"
   End Select

End Function

Private Function PointerToStringW(ByVal xi_lngPtr As Long) As String
On Error Resume Next                   ' Don't accept an error here
   Dim p_abytBuffer()                  As Byte
   Dim p_lngLen                        As Long
   Dim p_strTmp                        As String
   Dim p_lngRtn                        As Long
   
   ' ------------------------------------------
   ' Get the length of the string from the pointer
   ' ------------------------------------------
   If xi_lngPtr <> 0 Then
      p_lngLen = StrLenW(xi_lngPtr) * 2
   Else
      p_lngLen = 0
   End If
   
   ' ------------------------------------------
   ' Now convert to a string
   ' ------------------------------------------
   If xi_lngPtr <> 0 Then
      
      If p_lngLen > 0 Then
         ReDim p_abytBuffer(0 To (p_lngLen - 1)) As Byte
         CopyMem p_abytBuffer(0), ByVal xi_lngPtr, p_lngLen
         p_strTmp = p_abytBuffer
      Else
         p_strTmp = ""
      End If
   
   End If
   
   ' ------------------------------------------
   ' Set the return value
   ' ------------------------------------------
   PointerToStringW = p_strTmp
   
End Function
