Attribute VB_Name = "modSID"
Option Explicit

Private Declare Function CloseHandle _
    Lib "kernel32" _
    (ByVal hObject As Long) As Long
Private Declare Sub CopyMem _
    Lib "kernel32" Alias "RtlMoveMemory" _
    (pTo As Any, _
     pFrom As Any, _
     ByVal nCount As Long)
Private Declare Function GetCurrentProcess _
    Lib "kernel32" () As Long
Private Declare Function GetSidIdentifierAuthority _
    Lib "advapi32.dll" _
    (ByVal pSid As Long) As Long
Private Declare Function GetSidSubAuthority _
   Lib "advapi32.dll" _
   (ByVal pSid As Long, _
   ByVal nSubAuthority As Long) As Long
Private Declare Function GetSidSubAuthorityCount _
   Lib "advapi32.dll" _
   (ByVal pSid As Long) As Long
Private Declare Function GetTokenInformation _
   Lib "advapi32.dll" _
   (ByVal hToken As Long, _
    ByVal eTokenInformationClass As TOKEN_INFORMATION_CLASS, _
    uTokenInformation As Any, _
    ByVal nTokenInformationLength As Long, _
    nReturnLength As Long) As Long
Private Declare Function IsValidSid _
   Lib "advapi32.dll" _
   (ByVal pSid As Long) As Long
Private Declare Function OpenProcessToken _
   Lib "advapi32" _
   (ByVal hProcess As Long, _
    ByVal dwDesiredAccess As Long, _
    hToken As Long) As Long

Private Const TOKEN_QUERY As Long = &H8&
Private Const SID_REVISION As Long = 1&

Private Enum TOKEN_INFORMATION_CLASS
   TokenUser = 1&
   TokenGroups
   TokenPrivileges
   TokenOwner
   TokenPrimaryGroup
   TokenDefaultDacl
   TokenSource
   TokenType
   TokenImpersonationLevel
   TokenStatistics
   TokenRestrictedSids
   TokenSessionId
End Enum

Private Type SID_AND_ATTRIBUTES
   pSid As Long
   hAttributes As Long
End Type

Private Type SID_IDENTIFIER_AUTHORITY
   yValue(0 To 5) As Byte
End Type

Private Type TOKEN_USER
   uSid As SID_AND_ATTRIBUTES
End Type

Public Function GetTextualSid(ByVal pSid As Long) As String
   Dim pSidIdentifierAuthority As Long
   Dim pnSidSubAuthorityCount As Long
   Dim nSubAuthorityCount As Byte
   Dim uSidIdentifierAuthority As SID_IDENTIFIER_AUTHORITY
   Dim dIdentifierAuthority As Double
   Dim iSubAuthority As Long
   Dim pnSubAuthority As Long
   Dim nSubAuthority As Long
   Dim sSID As String

   If IsValidSid(pSid) Then
      pSidIdentifierAuthority = GetSidIdentifierAuthority(pSid)
      If pSidIdentifierAuthority Then
         CopyMem uSidIdentifierAuthority, ByVal pSidIdentifierAuthority, Len(uSidIdentifierAuthority)
         pnSidSubAuthorityCount = GetSidSubAuthorityCount(pSid)
         
         If pnSidSubAuthorityCount Then
            CopyMem nSubAuthorityCount, ByVal pnSidSubAuthorityCount, 1&
            
            If nSubAuthorityCount Then
               sSID = "S-" & CStr(SID_REVISION)
               
               With uSidIdentifierAuthority
                  If .yValue(0) Or .yValue(1) Then
                     sSID = sSID & "-0x" & ZeroFill(Hex$(.yValue(0)), 2) & _
                                           ZeroFill(Hex$(.yValue(1)), 2) & _
                                           ZeroFill(Hex$(.yValue(2)), 2) & _
                                           ZeroFill(Hex$(.yValue(3)), 2) & _
                                           ZeroFill(Hex$(.yValue(4)), 2) & _
                                           ZeroFill(Hex$(.yValue(5)), 2)
                  Else
                     dIdentifierAuthority = CDbl(.yValue(5)) + _
                                            CDbl(.yValue(4)) * CDbl(2 ^ 8) + _
                                            CDbl(.yValue(3)) * CDbl(2 ^ 16) + _
                                            CDbl(.yValue(2)) * CDbl(2 ^ 24)
                     sSID = sSID & "-" & CStr(dIdentifierAuthority)
                  End If
               End With
               
               For iSubAuthority = 0 To nSubAuthorityCount - 1
                  pnSubAuthority = GetSidSubAuthority(pSid, iSubAuthority)
                  If pnSubAuthority Then
                     CopyMem nSubAuthority, ByVal pnSubAuthority, 4&
                  End If
                  sSID = sSID & "-" & UnsignedLong(nSubAuthority)
               Next iSubAuthority
               
               GetTextualSid = sSID
            End If
         
         End If
      
      End If
   
   End If

End Function

Private Function ZeroFill(ByVal sHex As String, ByVal nChars As Long) As String
   ZeroFill = Right$(String$(nChars, "0") & sHex, nChars)
End Function

Private Function UnsignedLong(ByVal nLongValue As Long) As Double
   If nLongValue < 0 Then
       UnsignedLong = CDbl(nLongValue) + CDbl(2 ^ 32)
   Else
       UnsignedLong = nLongValue
   End If
End Function
